﻿//-----------------------------------------------
//-> Copyrights
//-----------------------------------------------
{$Copyright 'Брыкин Глеб Сергеевич'}
{$Company 'PABCSoft'}
{$Version 'v27.03.2018'}
{$Trademark 'BrainABC'}
//-----------------------------------------------
//-> Resources
//-----------------------------------------------
{$Resource 'MnistNet.PABCModel'}
{$Resource 'MainIcon.jpg'}
//-----------------------------------------------
//-> References
//-----------------------------------------------
{$Reference 'System.dll'}
{$Reference 'System.Drawing.dll'}
{$Reference 'System.Threading.dll'}
{$Reference 'System.Windows.Forms.dll'}
{$Reference 'System.IO.Compression.dll'}
//-----------------------------------------------
//-> Main Thread Type = STAThread
//-----------------------------------------------
{$AppType Windows}
//-----------------------------------------------
//-> Using's
//-----------------------------------------------
Uses System;
Uses System.IO;
Uses System.Drawing;
Uses System.Threading;
Uses System.Windows.Forms;
Uses System.IO.Compression;
Uses System.Threading.Tasks;
//-----------------------------------------------
//-> System Implementations
//-----------------------------------------------
type
  DrawingBox = Sealed Class(System.Windows.Forms.PictureBox)
    private BMP: System.Drawing.Bitmap;
    private G: System.Drawing.Graphics;
    private x: System.Int32;
    private y: System.Int32;
    public constructor Create(w, h: System.Int32);
    begin
      inherited Create();
      self.BMP := new System.Drawing.Bitmap(w, h);
      self.Size := new System.Drawing.Size(w, h);
      self.Image := self.BMP;
      self.G := System.Drawing.Graphics.FromImage(self.BMP);
      self.G.Clear(System.Drawing.Color.Black);
      self.Invalidate();
      self.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.MouseDown += OnDrawBoxMouseDown;
      self.MouseMove += OnDrawBoxMouseMove;
    end;
    
    private procedure OnDrawBoxMouseDown(sender: System.object; E: System.Windows.Forms.MouseEventArgs);
    begin
      if E.Button = System.Windows.Forms.MouseButtons.Left
      Then
      begin
        self.x := E.X;
        self.y := E.Y;
      end;
    end;
    
    private procedure OnDrawBoxMouseMove(sender: System.object; E: System.Windows.Forms.MouseEventArgs);
    begin
      if E.Button = System.Windows.Forms.MouseButtons.Left
      Then
      begin
        var g := System.Drawing.Graphics.FromImage((sender as System.Windows.Forms.PictureBox).Image);
        g.FillEllipse(System.Drawing.Brushes.White, self.x, self.y, 22, 22);
        self.x := E.X;
        self.y := E.Y;
        (sender as System.Windows.Forms.PictureBox).Invalidate();
      end;
    end;
    
    public procedure Clear();
    begin
      self.G.Clear(System.Drawing.Color.Black);
      self.Invalidate();
    end;
  End;

type
  Pointer = ^System.Void;

type
  PByte = ^System.Byte;

type
  Tensor = Sealed Class
    internal __W: array of System.Single;
    internal __Width: System.Int32;
    internal __Height: System.Int32;
    internal __Depth: System.Int32;
    public constructor Create(w: System.Int32; h: System.Int32; d: System.Int32);
    begin
      self.__Width := w;
      self.__Height := h;
      self.__Depth := d;
      self.__W := new System.Single[w * h * d];
    end;
    
    public Class function FromGrayScaleBMP(BMP: System.Drawing.Bitmap): Tensor;
    begin
      Result := new Tensor(BMP.Width, BMP.Height, 1);
      var BD := BMP.LockBits(new System.Drawing.Rectangle(0, 0, BMP.Width, BMP.Height), System.Drawing.Imaging.ImageLockMode.ReadOnly, System.Drawing.Imaging.PixelFormat.Format24bppRgb);
      for Var y := 0 to BMP.Height - 1 do
      begin
        var address: PByte := Pointer(BD.Scan0.ToInt32() + BD.Stride * y);
        for Var x := 0 to BMP.Width - 1 do
        begin
          var R := Address^;
          Address := Pointer(System.Int32(Address) + 1);
          var G := Address^;
          Address := Pointer(System.Int32(Address) + 1);
          var B := Address^;
          Address := Pointer(System.Int32(Address) + 1);
          Result.&Set(x, y, 0, (R + G + B) / 3);
        end;
      end;
      BMP.UnlockBits(BD);
      BD := nil;
    end;
    
    public function Get(x: System.Int32; y: System.Int32; d: System.Int32): System.Single;
    begin
      Result := self.__W[((self.__Width * y) + x) * self.__Depth + d];
    end;
    
    public procedure &Set(x: System.Int32; y: System.Int32; d: System.Int32; v: System.Single);
    begin
      self.__W[((self.__Width * y) + x) * self.__Depth + d] := v;
    end;
    
    public function ToBitmaps(): array of System.Drawing.Bitmap;
    begin
      Result := new System.Drawing.Bitmap[self.__Depth];
      for Var d := 0 to self.__Depth - 1 do
      begin
        Result[d] := new System.Drawing.Bitmap(self.__Width, self.__Height);
        var min: System.Single := 99999999.0;
        var max: System.Single := 0.0;
        for Var x := 0 to self.__Width - 1 do
        begin
          for Var y := 0 to self.__Height - 1 do
          begin
            var v := self.Get(x, y, d);
            if (v < min)
              Then min := v;
            if (v > max)
              Then max := v;
          end;
        end;
        var BD := Result[d].LockBits(new System.Drawing.Rectangle(0, 0, self.__Width, self.__Height), System.Drawing.Imaging.ImageLockMode.WriteOnly, System.Drawing.Imaging.PixelFormat.Format24bppRgb);
        for Var y := 0 to self.__Height - 1 do
        begin
          var Address: PByte := Pointer(BD.Scan0.ToInt32() + BD.Stride * y);
          for Var x := 0 to self.__Width - 1 do
          begin
            var r := ((self.Get(x, y, d) - min) / (max - min)) * 255.0;
            if (r < 0.0)
              Then r := 0.0;
            if (r > 255.0)
              Then r := 255.0;
            try
              begin
                Address^ := System.Convert.ToByte(r);
                Address := Pointer(System.Int32(Address) + 1);
                Address^ := System.Convert.ToByte(r);
                Address := Pointer(System.Int32(Address) + 1);
                Address^ := System.Convert.ToByte(r);
                Address := Pointer(System.Int32(Address) + 1);
              end;
            except
              on e: System.Exception do
              begin
              end;
            End;
          end;
        end;
        Result[d].UnlockBits(BD);
        BD := nil;
      end;
    end;
    
    public property Width: System.Int32 read __Width;
    public property Height: System.Int32 read __Height;
    public property Depth: System.Int32 read __Depth;
  End;

type
  Layers = Sealed Abstract Class
    public Class function ReLU(input: Tensor): Tensor;
    begin
      Result := new Tensor(input.__Width, input.__Height, input.__Depth);
      for Var i := 0 to input.__W.Length - 1 do
      begin
        var v: System.Single;
        v := input.__W[i];
        Result.__W[i] := (v > 0) ? (v) : (0);
      end;
    end;
    
    public Class function Conv(input: Tensor; Biases: Tensor; Filters: array of Tensor; Pad: System.Int32; Stride: System.Int32; FilterHeight: System.Int32; FilterWidth: System.Int32): Tensor;
    begin
      var OutputWidth := System.Convert.ToInt32(((input.__Width + (Pad * 2) - FilterWidth) / Stride) + 1);
      var OutputHeight := System.Convert.ToInt32(((input.__Height + (Pad * 2) - FilterHeight) / Stride) + 1);
      var OutputDepth := Filters.Length;
      var tempOutput := new Tensor(OutputWidth or 0, OutputHeight or 0, OutputDepth or 0);
      var inputWidth := input.__Width or 0;
      var inputHeight := input.__Height or 0;
      var xy_stride := Stride or 0;
      System.Threading.Tasks.Parallel.For(0, OutputDepth, Procedure(d: System.Int32)->
            begin
              for Var ay := 0 to OutputHeight - 1 do
              begin
                var y := (-Pad or 0) + (xy_stride * ay);
                var f := Filters[d];
                for var ax := 0 to OutputWidth - 1 do
                begin
                  var x := (-Pad or 0) + (xy_stride * ax);
                  var a := 0.0;
                  for var fy := 0 to f.__Height - 1 do
                  begin
                    var oy := y + fy;
                    for var fx := 0 to f.__Width - 1 do
                    begin
                      var ox := x + fx;
                      if (oy >= 0) and (oy < inputHeight) and (ox >= 0) and (ox < inputWidth)
                      Then
                      begin
                        for var fd := 0 to f.__Depth - 1 do
                        begin
                          a += f.__W[((f.__Width * fy) + fx) * f.__Depth + fd] * input.__W[((inputWidth * oy) + ox) * input.__Depth + fd];
                        end;
                      end;
                    end;
                  end;
                  a += Biases.__W[d];
                  tempOutput.&Set(ax, ay, d, System.Single(a));
                end;
              end;
            end);
      Result := tempOutput;
    end;
    
    public Class function Pool(input: Tensor; KernelWidth: System.Int32; KernelHeight: System.Int32; Stride: System.Int32; Pad: System.Int32): Tensor;
    begin
      var OutputWidth := System.Convert.ToInt32(((Input.__Width + (Pad * 2) - KernelWidth) / Stride) + 1);
      var OutputHeight := System.Convert.ToInt32(((Input.__Height + (Pad * 2) - KernelHeight) / Stride) + 1);
      var OutputDepth := input.__Depth;
      var A := new Tensor(OutputWidth, OutputHeight, OutputDepth);
      for Var d := 0 to OutputDepth - 1 do
      begin
        for var ax := 0 to OutputWidth - 1 do
        begin
          var x := -Pad;
          x += (Stride * ax);
          for var ay := 0 to OutputHeight - 1 do
          begin
            var y := -Pad; 
            y += (Stride * ay); 
            var _a: System.Single := -99999;
            for var fx := 0 to KernelWidth - 1 do
            begin
              for var fy := 0 to KernelHeight - 1 do
              begin
                var oy := y + fy;
                var ox := x + fx;
                if (oy >= 0) and (oy < input.__Height) and (ox >= 0) and (ox < input.__Width)
                Then
                begin
                  var v := input.Get(ox, oy, d);
                  if (v > _a)
                    Then _a := v;
                end;
              end;
            end;
            A.Set(ax, ay, d, _a);
          end;
        end;
      end;
      Result := A;
    end;
    
    public Class function FullyConn(input: Tensor; Biases: Tensor; Filters: array of Tensor): Tensor;
    begin
      var OutputDepth := Filters.Length;
      var A := new Tensor(1, 1, OutputDepth);
      var Vw := input.__W;
      var num_inputs := input.__Depth * input.__Height * input.__Width;
      for Var i := 0 to OutputDepth - 1 do
      begin
        var _a := 0.0;
        var wi := Filters[i].__W;
        for var d := 0 to num_inputs - 1 do
        begin
          _a += Vw[d] * wi[d];
        end;
        _a += Biases.__W[i];
        A.__W[i] := _a;
      end;
      Result := A;
    end;
    
    public Class function SoftMax(input: Tensor): Tensor;
    begin
      var Out_Depth := input.__Depth * input.__Height * input.__Width;
      var A := new Tensor(1, 1, Out_Depth);
      var ass := input.__W;
      var amax := input.__W[0];
      for var i := 1 to ass.Length - 1 do
      begin
        if (ass[i] > amax)
          Then amax := ass[i];
      end;
      var es := new System.Single[Out_Depth];
      var esum := 0.0;
      for var i := 0 to Out_Depth - 1 do
      begin
        var e := System.Single(System.Math.Exp(ass[i] - amax));
        esum += e;
        es[i] := e;
      end;
      for var i := 0 to Out_Depth - 1 do
      begin
        es[i] /= System.Single(esum);
        A.__W[i] := es[i];
      end;
      Result := A;
    end;
  End;

type
  MainForm = Sealed Class(System.Windows.Forms.Form)
    //-> Input
    private InputPanel: System.Windows.Forms.Panel;
    private InputLabel: System.Windows.Forms.Label;
    private MainDrawingBox: DrawingBox;
    private RecognizeButton: System.Windows.Forms.Button;
    private ClearButton: System.Windows.Forms.Button;
    //-> Conv1
    private Conv1Label: System.Windows.Forms.Label;
    private Conv1Panel: System.Windows.Forms.Panel;
    private Conv1Map1: System.Windows.Forms.PictureBox;
    private Conv1Map2: System.Windows.Forms.PictureBox;
    private Conv1Map3: System.Windows.Forms.PictureBox;
    private Conv1Map4: System.Windows.Forms.PictureBox;
    private Conv1Map5: System.Windows.Forms.PictureBox;
    private Conv1Map6: System.Windows.Forms.PictureBox;
    private Conv1Map7: System.Windows.Forms.PictureBox;
    private Conv1Map8: System.Windows.Forms.PictureBox;
    //-> ReLU1
    private ReLU1Label: System.Windows.Forms.Label;
    private ReLU1Panel: System.Windows.Forms.Panel;
    private ReLU1Map1: System.Windows.Forms.PictureBox;
    private ReLU1Map2: System.Windows.Forms.PictureBox;
    private ReLU1Map3: System.Windows.Forms.PictureBox;
    private ReLU1Map4: System.Windows.Forms.PictureBox;
    private ReLU1Map5: System.Windows.Forms.PictureBox;
    private ReLU1Map6: System.Windows.Forms.PictureBox;
    private ReLU1Map7: System.Windows.Forms.PictureBox;
    private ReLU1Map8: System.Windows.Forms.PictureBox;
    //-> Pool1
    private Pool1Label: System.Windows.Forms.Label;
    private Pool1Panel: System.Windows.Forms.Panel;
    private Pool1Map1: System.Windows.Forms.PictureBox;
    private Pool1Map2: System.Windows.Forms.PictureBox;
    private Pool1Map3: System.Windows.Forms.PictureBox;
    private Pool1Map4: System.Windows.Forms.PictureBox;
    private Pool1Map5: System.Windows.Forms.PictureBox;
    private Pool1Map6: System.Windows.Forms.PictureBox;
    private Pool1Map7: System.Windows.Forms.PictureBox;
    private Pool1Map8: System.Windows.Forms.PictureBox;
    //-> Conv2
    private Conv2Label: System.Windows.Forms.Label;
    private Conv2Panel: System.Windows.Forms.Panel;
    private Conv2Map1: System.Windows.Forms.PictureBox;
    private Conv2Map2: System.Windows.Forms.PictureBox;
    private Conv2Map3: System.Windows.Forms.PictureBox;
    private Conv2Map4: System.Windows.Forms.PictureBox;
    private Conv2Map5: System.Windows.Forms.PictureBox;
    private Conv2Map6: System.Windows.Forms.PictureBox;
    private Conv2Map7: System.Windows.Forms.PictureBox;
    private Conv2Map8: System.Windows.Forms.PictureBox;
    private Conv2Map9: System.Windows.Forms.PictureBox;
    private Conv2Map10: System.Windows.Forms.PictureBox;
    private Conv2Map11: System.Windows.Forms.PictureBox;
    private Conv2Map12: System.Windows.Forms.PictureBox;
    private Conv2Map13: System.Windows.Forms.PictureBox;
    private Conv2Map14: System.Windows.Forms.PictureBox;
    private Conv2Map15: System.Windows.Forms.PictureBox;
    private Conv2Map16: System.Windows.Forms.PictureBox;
    //-> ReLU2
    private ReLU2Label: System.Windows.Forms.Label;
    private ReLU2Panel: System.Windows.Forms.Panel;
    private ReLU2Map1: System.Windows.Forms.PictureBox;
    private ReLU2Map2: System.Windows.Forms.PictureBox;
    private ReLU2Map3: System.Windows.Forms.PictureBox;
    private ReLU2Map4: System.Windows.Forms.PictureBox;
    private ReLU2Map5: System.Windows.Forms.PictureBox;
    private ReLU2Map6: System.Windows.Forms.PictureBox;
    private ReLU2Map7: System.Windows.Forms.PictureBox;
    private ReLU2Map8: System.Windows.Forms.PictureBox;
    private ReLU2Map9: System.Windows.Forms.PictureBox;
    private ReLU2Map10: System.Windows.Forms.PictureBox;
    private ReLU2Map11: System.Windows.Forms.PictureBox;
    private ReLU2Map12: System.Windows.Forms.PictureBox;
    private ReLU2Map13: System.Windows.Forms.PictureBox;
    private ReLU2Map14: System.Windows.Forms.PictureBox;
    private ReLU2Map15: System.Windows.Forms.PictureBox;
    private ReLU2Map16: System.Windows.Forms.PictureBox;
    //-> Pool2
    private Pool2Label: System.Windows.Forms.Label;
    private Pool2Panel: System.Windows.Forms.Panel;
    private Pool2Map1: System.Windows.Forms.PictureBox;
    private Pool2Map2: System.Windows.Forms.PictureBox;
    private Pool2Map3: System.Windows.Forms.PictureBox;
    private Pool2Map4: System.Windows.Forms.PictureBox;
    private Pool2Map5: System.Windows.Forms.PictureBox;
    private Pool2Map6: System.Windows.Forms.PictureBox;
    private Pool2Map7: System.Windows.Forms.PictureBox;
    private Pool2Map8: System.Windows.Forms.PictureBox;
    private Pool2Map9: System.Windows.Forms.PictureBox;
    private Pool2Map10: System.Windows.Forms.PictureBox;
    private Pool2Map11: System.Windows.Forms.PictureBox;
    private Pool2Map12: System.Windows.Forms.PictureBox;
    private Pool2Map13: System.Windows.Forms.PictureBox;
    private Pool2Map14: System.Windows.Forms.PictureBox;
    private Pool2Map15: System.Windows.Forms.PictureBox;
    private Pool2Map16: System.Windows.Forms.PictureBox;
    //-> FC1
    private FC1Label: System.Windows.Forms.Label;
    private FC1Panel: System.Windows.Forms.Panel;
    private FC1Map1: System.Windows.Forms.PictureBox;
    private FC1Map2: System.Windows.Forms.PictureBox;
    private FC1Map3: System.Windows.Forms.PictureBox;
    private FC1Map4: System.Windows.Forms.PictureBox;
    private FC1Map5: System.Windows.Forms.PictureBox;
    private FC1Map6: System.Windows.Forms.PictureBox;
    private FC1Map7: System.Windows.Forms.PictureBox;
    private FC1Map8: System.Windows.Forms.PictureBox;
    private FC1Map9: System.Windows.Forms.PictureBox;
    private FC1Map10: System.Windows.Forms.PictureBox;
    //-> SM1
    private SM1Label: System.Windows.Forms.Label;
    private SM1Panel: System.Windows.Forms.Panel;
    private SM1Map1: System.Windows.Forms.PictureBox;
    private SM1Map2: System.Windows.Forms.PictureBox;
    private SM1Map3: System.Windows.Forms.PictureBox;
    private SM1Map4: System.Windows.Forms.PictureBox;
    private SM1Map5: System.Windows.Forms.PictureBox;
    private SM1Map6: System.Windows.Forms.PictureBox;
    private SM1Map7: System.Windows.Forms.PictureBox;
    private SM1Map8: System.Windows.Forms.PictureBox;
    private SM1Map9: System.Windows.Forms.PictureBox;
    private SM1Map10: System.Windows.Forms.PictureBox;
    //-> Prediction
    private PredictionLabel: System.Windows.Forms.Label;
    private PredictionPanel: System.Windows.Forms.Panel;
    private PredictionResult: System.Windows.Forms.Label;
    //-> Filters and Biases
    private Conv1Filters: array of Tensor;
    private Conv1Biases: Tensor;
    private Conv2Filters: array of Tensor;
    private Conv2Biases: Tensor;
    private FC1Filters: array of Tensor;
    private FC1Biases: Tensor;
    private function Decompress(Input: System.IO.Stream): MemoryStream;
    begin
      Result := new System.IO.MemoryStream(45096);
      var Decompressor := new System.IO.Compression.GZipStream(Input, System.IO.Compression.CompressionMode.Decompress);
      var Buffer := new System.Byte[45096];
      DeCompressor.Read(Buffer, 0, Buffer.Length);
      Result.Write(Buffer, 0, Buffer.Length);
      Buffer := nil;
      Decompressor := nil;
      Result.Position := 0;
      System.GC.Collect();
    end;
    
    private function ResizeImages(Width: System.Int32; Height: System.Int32; params Images: array of System.Drawing.Bitmap): array of System.Drawing.Bitmap;
    begin
      Result := new System.Drawing.Bitmap[Images.Length];
      for Var i := 0 to Images.Length - 1 do
      begin
        Result[i] := new System.Drawing.Bitmap(Width, Height);
        var G := System.Drawing.Graphics.FromImage(Result[i]);
        G.Clear(Images[i].GetPixel(0, 0));
        G := nil;
      end;
    end;
    
    private function LoadWeights(n: System.Int32; d: System.Int32; h: System.Int32; w: System.Int32; s: System.IO.Stream): array of Tensor;
    begin
      Result := new Tensor[n];
      for Var i := 0 to n - 1 do
      begin
        Result[i] := new Tensor(w, h, d);
      end;
      var SR := new System.IO.BinaryReader(s);
      for Var _n := 0 to n - 1 do
        for Var _d := 0 to d - 1 do
          for Var _h := 0 to h - 1 do
            for Var _w := 0 to w - 1 do
            begin
              Result[_n].&Set(_w, _h, _d, SR.ReadSingle());
            end;
      SR := nil;
    end;
    
    private function LoadBiases(n: System.Int32; s: System.IO.Stream): Tensor;
    begin
      Result := new Tensor(1, 1, n);
      var SR := new System.IO.BinaryReader(s);
      for Var _n := 0 to n - 1 do
      begin
        Result.&Set(0, 0, _n, SR.ReadSingle());
      end;
      SR := nil;
    end;
    
    private function GetPrediction(input: Tensor): System.Int32;
    begin
      var maxv := input.__W[0];
      var maxi := 0;
      for Var i := 1 to input.__W.Length - 1 do
      begin
        if (input.__W[i] > maxv)
        Then
        begin
          maxv := input.__W[i];
          maxi := i;
        end;
      end;
      Result := maxi;
    end;
    
    public constructor Create();
    begin
      //-> MainForm initialization
      inherited Create();
      self.Text := 'PABCSoft - MnistNet';
      self.Icon := System.Drawing.Icon.FromHandle((new System.Drawing.Bitmap(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream('MainIcon.jpg'))).GetHicon());
      self.ClientSize := new System.Drawing.Size(856, 480);
      self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedSingle;
      self.MinimizeBox := False;
      self.MaximizeBox := False;
      //-> Loading Filters and Biases
      var Data := Decompress(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream('MnistNet.PABCModel'));
      self.Conv1Filters := self.LoadWeights(8, 1, 5, 5, Data);
      self.Conv1Biases := self.LoadBiases(8, Data);
      self.Conv2Filters := self.LoadWeights(16, 8, 5, 5, Data);
      self.Conv2Biases := self.LoadBiases(16, Data);
      self.FC1Filters := self.LoadWeights(10, 784, 1, 1, Data);
      self.FC1Biases := self.LoadBiases(10, Data);
      //-> InputLabel
      self.InputLabel := new System.Windows.Forms.Label();
      self.InputLabel.Text := 'Input';
      self.InputLabel.Width := 266;
      self.InputLabel.Height := 25;
      self.InputLabel.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.InputLabel.Left := 10;
      self.Controls.Add(self.InputLabel);
      //-> InputPanel
      self.InputPanel := new System.Windows.Forms.Panel();
      self.InputPanel.Width := 266;
      self.InputPanel.Height := 445;
      self.InputPanel.Left := 10;
      self.InputPanel.Top := 25;
      self.InputPanel.BackColor := System.Drawing.Color.White;
      self.InputPanel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      //-> MainDrawingBox
      self.MainDrawingBox := new DrawingBox(256, 256);
      self.MainDrawingBox.Top := 64;
      self.MainDrawingBox.Left := 5;
      self.InputPanel.Controls.Add(self.MainDrawingBox);
      //-> RecognizeButton
      self.RecognizeButton := new System.Windows.Forms.Button();
      self.RecognizeButton.Top := 320;
      self.RecognizeButton.Left := 5;
      self.RecognizeButton.Width := 256;
      self.RecognizeButton.Height := 30;
      self.RecognizeButton.Text := 'Распознать!';
      self.RecognizeButton.Click += self.Recognize;
      self.InputPanel.Controls.Add(self.RecognizeButton);
      //-> ClearButton
      self.ClearButton := new System.Windows.Forms.Button();
      self.ClearButton.Top := 350;
      self.ClearButton.Left := 5;
      self.ClearButton.Width := 256;
      self.ClearButton.Height := 30;
      self.ClearButton.Text := 'Очистить';
      self.ClearButton.Click += self.ClearInput;
      self.InputPanel.Controls.Add(self.ClearButton);
      self.Controls.Add(self.InputPanel);
      //-> Conv1Label
      self.Conv1Label := new System.Windows.Forms.Label();
      self.Conv1Label.Text := 'Conv1';
      self.Conv1Label.Left := 286;
      self.Conv1Label.Width := 48;
      self.Conv1Label.Height := 25;
      self.Conv1Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.Conv1Label);
      //-> Conv1Panel
      self.Conv1Panel := new System.Windows.Forms.Panel();
      self.Conv1Panel.Top := 25;
      self.Conv1Panel.Left := 286;
      self.Conv1Panel.Width := 48;
      self.Conv1Panel.Height := 445;
      self.Conv1Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.Conv1Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.Conv1Map1 := new System.Windows.Forms.PictureBox();
      self.Conv1Map1.Top := 75;
      self.Conv1Map1.Left := 10;
      self.Conv1Map1.Width := 28;
      self.Conv1Map1.Height := 28;
      self.Conv1Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map1.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map1);
      //-> Map2
      self.Conv1Map2 := new System.Windows.Forms.PictureBox();
      self.Conv1Map2.Top := 113;
      self.Conv1Map2.Left := 10;
      self.Conv1Map2.Width := 28;
      self.Conv1Map2.Height := 28;
      self.Conv1Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map2.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map2);
      //-> Map3
      self.Conv1Map3 := new System.Windows.Forms.PictureBox();
      self.Conv1Map3.Top := 151;
      self.Conv1Map3.Left := 10;
      self.Conv1Map3.Width := 28;
      self.Conv1Map3.Height := 28;
      self.Conv1Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map3.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map3);
      //-> Map4
      self.Conv1Map4 := new System.Windows.Forms.PictureBox();
      self.Conv1Map4.Top := 189;
      self.Conv1Map4.Left := 10;
      self.Conv1Map4.Width := 28;
      self.Conv1Map4.Height := 28;
      self.Conv1Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map4.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map4);
      //-> Map5
      self.Conv1Map5 := new System.Windows.Forms.PictureBox();
      self.Conv1Map5.Top := 227;
      self.Conv1Map5.Left := 10;
      self.Conv1Map5.Width := 28;
      self.Conv1Map5.Height := 28;
      self.Conv1Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map5.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map5);
      //-> Map6
      self.Conv1Map6 := new System.Windows.Forms.PictureBox();
      self.Conv1Map6.Top := 265;
      self.Conv1Map6.Left := 10;
      self.Conv1Map6.Width := 28;
      self.Conv1Map6.Height := 28;
      self.Conv1Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map6.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map6);
      //-> Map7
      self.Conv1Map7 := new System.Windows.Forms.PictureBox();
      self.Conv1Map7.Top := 303;
      self.Conv1Map7.Left := 10;
      self.Conv1Map7.Width := 28;
      self.Conv1Map7.Height := 28;
      self.Conv1Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map7.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map7);
      //-> Map8
      self.Conv1Map8 := new System.Windows.Forms.PictureBox();
      self.Conv1Map8.Top := 341;
      self.Conv1Map8.Left := 10;
      self.Conv1Map8.Width := 28;
      self.Conv1Map8.Height := 28;
      self.Conv1Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv1Map8.BackColor := System.Drawing.Color.Gray;
      self.Conv1Panel.Controls.Add(self.Conv1Map8);
      self.Controls.Add(self.Conv1Panel);
      //-> ReLU1Label
      self.ReLU1Label := new System.Windows.Forms.Label();
      self.ReLU1Label.Text := 'ReLU1';
      self.ReLU1Label.Left := 344;
      self.ReLU1Label.Width := 48;
      self.ReLU1Label.Height := 25;
      self.ReLU1Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.ReLU1Label);
      //-> ReLU1Panel
      self.ReLU1Panel := new System.Windows.Forms.Panel();
      self.ReLU1Panel.Top := 25;
      self.ReLU1Panel.Left := 344;
      self.ReLU1Panel.Width := 48;
      self.ReLU1Panel.Height := 445;
      self.ReLU1Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.ReLU1Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.ReLU1Map1 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map1.Top := 75;
      self.ReLU1Map1.Left := 10;
      self.ReLU1Map1.Width := 28;
      self.ReLU1Map1.Height := 28;
      self.ReLU1Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map1.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map1);
      //-> Map2
      self.ReLU1Map2 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map2.Top := 113;
      self.ReLU1Map2.Left := 10;
      self.ReLU1Map2.Width := 28;
      self.ReLU1Map2.Height := 28;
      self.ReLU1Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map2.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map2);
      //-> Map3
      self.ReLU1Map3 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map3.Top := 151;
      self.ReLU1Map3.Left := 10;
      self.ReLU1Map3.Width := 28;
      self.ReLU1Map3.Height := 28;
      self.ReLU1Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map3.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map3);
      //-> Map4
      self.ReLU1Map4 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map4.Top := 189;
      self.ReLU1Map4.Left := 10;
      self.ReLU1Map4.Width := 28;
      self.ReLU1Map4.Height := 28;
      self.ReLU1Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map4.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map4);
      //-> Map5
      self.ReLU1Map5 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map5.Top := 227;
      self.ReLU1Map5.Left := 10;
      self.ReLU1Map5.Width := 28;
      self.ReLU1Map5.Height := 28;
      self.ReLU1Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map5.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map5);
      //-> Map6
      self.ReLU1Map6 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map6.Top := 265;
      self.ReLU1Map6.Left := 10;
      self.ReLU1Map6.Width := 28;
      self.ReLU1Map6.Height := 28;
      self.ReLU1Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map6.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map6);
      //-> Map7
      self.ReLU1Map7 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map7.Top := 303;
      self.ReLU1Map7.Left := 10;
      self.ReLU1Map7.Width := 28;
      self.ReLU1Map7.Height := 28;
      self.ReLU1Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map7.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map7);
      //-> Map8
      self.ReLU1Map8 := new System.Windows.Forms.PictureBox();
      self.ReLU1Map8.Top := 341;
      self.ReLU1Map8.Left := 10;
      self.ReLU1Map8.Width := 28;
      self.ReLU1Map8.Height := 28;
      self.ReLU1Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU1Map8.BackColor := System.Drawing.Color.Gray;
      self.ReLU1Panel.Controls.Add(self.ReLU1Map8);
      self.Controls.Add(self.ReLU1Panel);
      //-> Pool1Label
      self.Pool1Label := new System.Windows.Forms.Label();
      self.Pool1Label.Text := 'Pool1';
      self.Pool1Label.Left := 402;
      self.Pool1Label.Width := 48;
      self.Pool1Label.Height := 25;
      self.Pool1Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.Pool1Label);
      //-> Pool1Panel
      self.Pool1Panel := new System.Windows.Forms.Panel();
      self.Pool1Panel.Top := 25;
      self.Pool1Panel.Left := 402;
      self.Pool1Panel.Width := 48;
      self.Pool1Panel.Height := 445;
      self.Pool1Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.Pool1Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.Pool1Map1 := new System.Windows.Forms.PictureBox();
      self.Pool1Map1.Top := 131;
      self.Pool1Map1.Left := 17;
      self.Pool1Map1.Width := 14;
      self.Pool1Map1.Height := 14;
      self.Pool1Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map1.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map1);
      //-> Map2
      self.Pool1Map2 := new System.Windows.Forms.PictureBox();
      self.Pool1Map2.Top := 155;
      self.Pool1Map2.Left := 17;
      self.Pool1Map2.Width := 14;
      self.Pool1Map2.Height := 14;
      self.Pool1Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map2.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map2);
      //-> Map3
      self.Pool1Map3 := new System.Windows.Forms.PictureBox();
      self.Pool1Map3.Top := 179;
      self.Pool1Map3.Left := 17;
      self.Pool1Map3.Width := 14;
      self.Pool1Map3.Height := 14;
      self.Pool1Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map3.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map3);
      //-> Map4
      self.Pool1Map4 := new System.Windows.Forms.PictureBox();
      self.Pool1Map4.Top := 203;
      self.Pool1Map4.Left := 17;
      self.Pool1Map4.Width := 14;
      self.Pool1Map4.Height := 14;
      self.Pool1Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map4.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map4);
      //-> Map5
      self.Pool1Map5 := new System.Windows.Forms.PictureBox();
      self.Pool1Map5.Top := 227;
      self.Pool1Map5.Left := 17;
      self.Pool1Map5.Width := 14;
      self.Pool1Map5.Height := 14;
      self.Pool1Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map5.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map5);
      //-> Map6
      self.Pool1Map6 := new System.Windows.Forms.PictureBox();
      self.Pool1Map6.Top := 251;
      self.Pool1Map6.Left := 17;
      self.Pool1Map6.Width := 14;
      self.Pool1Map6.Height := 14;
      self.Pool1Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map6.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map6);
      //-> Map7
      self.Pool1Map7 := new System.Windows.Forms.PictureBox();
      self.Pool1Map7.Top := 275;
      self.Pool1Map7.Left := 17;
      self.Pool1Map7.Width := 14;
      self.Pool1Map7.Height := 14;
      self.Pool1Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map7.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map7);
      //-> Map8
      self.Pool1Map8 := new System.Windows.Forms.PictureBox();
      self.Pool1Map8.Top := 299;
      self.Pool1Map8.Left := 17;
      self.Pool1Map8.Width := 14;
      self.Pool1Map8.Height := 14;
      self.Pool1Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool1Map8.BackColor := System.Drawing.Color.Gray;
      self.Pool1Panel.Controls.Add(self.Pool1Map8);
      self.Controls.Add(self.Pool1Panel);
      //-> Conv2Label
      self.Conv2Label := new System.Windows.Forms.Label();
      self.Conv2Label.Text := 'Conv2';
      self.Conv2Label.Left := 460;
      self.Conv2Label.Width := 48;
      self.Conv2Label.Height := 25;
      self.Conv2Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.Conv2Label);
      //-> Conv2Panel
      self.Conv2Panel := new System.Windows.Forms.Panel();
      self.Conv2Panel.Top := 25;
      self.Conv2Panel.Left := 460;
      self.Conv2Panel.Width := 48;
      self.Conv2Panel.Height := 445;
      self.Conv2Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.Conv2Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.Conv2Map1 := new System.Windows.Forms.PictureBox();
      self.Conv2Map1.Top := 35;
      self.Conv2Map1.Left := 17;
      self.Conv2Map1.Width := 14;
      self.Conv2Map1.Height := 14;
      self.Conv2Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map1.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map1);
      //-> Map2
      self.Conv2Map2 := new System.Windows.Forms.PictureBox();
      self.Conv2Map2.Top := 59;
      self.Conv2Map2.Left := 17;
      self.Conv2Map2.Width := 14;
      self.Conv2Map2.Height := 14;
      self.Conv2Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map2.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map2);
      //-> Map3
      self.Conv2Map3 := new System.Windows.Forms.PictureBox();
      self.Conv2Map3.Top := 83;
      self.Conv2Map3.Left := 17;
      self.Conv2Map3.Width := 14;
      self.Conv2Map3.Height := 14;
      self.Conv2Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map3.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map3);
      //-> Map4
      self.Conv2Map4 := new System.Windows.Forms.PictureBox();
      self.Conv2Map4.Top := 107;
      self.Conv2Map4.Left := 17;
      self.Conv2Map4.Width := 14;
      self.Conv2Map4.Height := 14;
      self.Conv2Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map4.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map4);
      //-> Map5
      self.Conv2Map5 := new System.Windows.Forms.PictureBox();
      self.Conv2Map5.Top := 131;
      self.Conv2Map5.Left := 17;
      self.Conv2Map5.Width := 14;
      self.Conv2Map5.Height := 14;
      self.Conv2Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map5.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map5);
      //-> Map6
      self.Conv2Map6 := new System.Windows.Forms.PictureBox();
      self.Conv2Map6.Top := 155;
      self.Conv2Map6.Left := 17;
      self.Conv2Map6.Width := 14;
      self.Conv2Map6.Height := 14;
      self.Conv2Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map6.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map6);
      //-> Map7
      self.Conv2Map7 := new System.Windows.Forms.PictureBox();
      self.Conv2Map7.Top := 179;
      self.Conv2Map7.Left := 17;
      self.Conv2Map7.Width := 14;
      self.Conv2Map7.Height := 14;
      self.Conv2Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map7.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map7);
      //-> Map8
      self.Conv2Map8 := new System.Windows.Forms.PictureBox();
      self.Conv2Map8.Top := 203;
      self.Conv2Map8.Left := 17;
      self.Conv2Map8.Width := 14;
      self.Conv2Map8.Height := 14;
      self.Conv2Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map8.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map8);
      //-> Map9
      self.Conv2Map9 := new System.Windows.Forms.PictureBox();
      self.Conv2Map9.Top := 227;
      self.Conv2Map9.Left := 17;
      self.Conv2Map9.Width := 14;
      self.Conv2Map9.Height := 14;
      self.Conv2Map9.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map9.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map9);
      //-> Map10
      self.Conv2Map10 := new System.Windows.Forms.PictureBox();
      self.Conv2Map10.Top := 251;
      self.Conv2Map10.Left := 17;
      self.Conv2Map10.Width := 14;
      self.Conv2Map10.Height := 14;
      self.Conv2Map10.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map10.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map10);
      //-> Map11
      self.Conv2Map11 := new System.Windows.Forms.PictureBox();
      self.Conv2Map11.Top := 275;
      self.Conv2Map11.Left := 17;
      self.Conv2Map11.Width := 14;
      self.Conv2Map11.Height := 14;
      self.Conv2Map11.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map11.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map11);
      //-> Map12
      self.Conv2Map12 := new System.Windows.Forms.PictureBox();
      self.Conv2Map12.Top := 299;
      self.Conv2Map12.Left := 17;
      self.Conv2Map12.Width := 14;
      self.Conv2Map12.Height := 14;
      self.Conv2Map12.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map12.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map12);
      //-> Map13
      self.Conv2Map13 := new System.Windows.Forms.PictureBox();
      self.Conv2Map13.Top := 323;
      self.Conv2Map13.Left := 17;
      self.Conv2Map13.Width := 14;
      self.Conv2Map13.Height := 14;
      self.Conv2Map13.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map13.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map13);
      //-> Map14
      self.Conv2Map14 := new System.Windows.Forms.PictureBox();
      self.Conv2Map14.Top := 347;
      self.Conv2Map14.Left := 17;
      self.Conv2Map14.Width := 14;
      self.Conv2Map14.Height := 14;
      self.Conv2Map14.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map14.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map14);
      //-> Map15
      self.Conv2Map15 := new System.Windows.Forms.PictureBox();
      self.Conv2Map15.Top := 371;
      self.Conv2Map15.Left := 17;
      self.Conv2Map15.Width := 14;
      self.Conv2Map15.Height := 14;
      self.Conv2Map15.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map15.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map15);
      //-> Map16
      self.Conv2Map16 := new System.Windows.Forms.PictureBox();
      self.Conv2Map16.Top := 395;
      self.Conv2Map16.Left := 17;
      self.Conv2Map16.Width := 14;
      self.Conv2Map16.Height := 14;
      self.Conv2Map16.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Conv2Map16.BackColor := System.Drawing.Color.Gray;
      self.Conv2Panel.Controls.Add(self.Conv2Map16);
      self.Controls.Add(self.Conv2Panel);
      //-> ReLU2Label
      self.ReLU2Label := new System.Windows.Forms.Label();
      self.ReLU2Label.Text := 'ReLU2';
      self.ReLU2Label.Left := 518;
      self.ReLU2Label.Width := 48;
      self.ReLU2Label.Height := 25;
      self.ReLU2Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.ReLU2Label);
      //-> ReLU2Panel
      self.ReLU2Panel := new System.Windows.Forms.Panel();
      self.ReLU2Panel.Top := 25;
      self.ReLU2Panel.Left := 518;
      self.ReLU2Panel.Width := 48;
      self.ReLU2Panel.Height := 445;
      self.ReLU2Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.ReLU2Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.ReLU2Map1 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map1.Top := 35;
      self.ReLU2Map1.Left := 17;
      self.ReLU2Map1.Width := 14;
      self.ReLU2Map1.Height := 14;
      self.ReLU2Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map1.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map1);
      //-> Map2
      self.ReLU2Map2 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map2.Top := 59;
      self.ReLU2Map2.Left := 17;
      self.ReLU2Map2.Width := 14;
      self.ReLU2Map2.Height := 14;
      self.ReLU2Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map2.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map2);
      //-> Map3
      self.ReLU2Map3 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map3.Top := 83;
      self.ReLU2Map3.Left := 17;
      self.ReLU2Map3.Width := 14;
      self.ReLU2Map3.Height := 14;
      self.ReLU2Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map3.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map3);
      //-> Map4
      self.ReLU2Map4 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map4.Top := 107;
      self.ReLU2Map4.Left := 17;
      self.ReLU2Map4.Width := 14;
      self.ReLU2Map4.Height := 14;
      self.ReLU2Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map4.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map4);
      //-> Map5
      self.ReLU2Map5 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map5.Top := 131;
      self.ReLU2Map5.Left := 17;
      self.ReLU2Map5.Width := 14;
      self.ReLU2Map5.Height := 14;
      self.ReLU2Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map5.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map5);
      //-> Map6
      self.ReLU2Map6 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map6.Top := 155;
      self.ReLU2Map6.Left := 17;
      self.ReLU2Map6.Width := 14;
      self.ReLU2Map6.Height := 14;
      self.ReLU2Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map6.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map6);
      //-> Map7
      self.ReLU2Map7 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map7.Top := 179;
      self.ReLU2Map7.Left := 17;
      self.ReLU2Map7.Width := 14;
      self.ReLU2Map7.Height := 14;
      self.ReLU2Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map7.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map7);
      //-> Map8
      self.ReLU2Map8 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map8.Top := 203;
      self.ReLU2Map8.Left := 17;
      self.ReLU2Map8.Width := 14;
      self.ReLU2Map8.Height := 14;
      self.ReLU2Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map8.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map8);
      //-> Map9
      self.ReLU2Map9 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map9.Top := 227;
      self.ReLU2Map9.Left := 17;
      self.ReLU2Map9.Width := 14;
      self.ReLU2Map9.Height := 14;
      self.ReLU2Map9.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map9.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map9);
      //-> Map10
      self.ReLU2Map10 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map10.Top := 251;
      self.ReLU2Map10.Left := 17;
      self.ReLU2Map10.Width := 14;
      self.ReLU2Map10.Height := 14;
      self.ReLU2Map10.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map10.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map10);
      //-> Map11
      self.ReLU2Map11 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map11.Top := 275;
      self.ReLU2Map11.Left := 17;
      self.ReLU2Map11.Width := 14;
      self.ReLU2Map11.Height := 14;
      self.ReLU2Map11.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map11.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map11);
      //-> Map12
      self.ReLU2Map12 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map12.Top := 299;
      self.ReLU2Map12.Left := 17;
      self.ReLU2Map12.Width := 14;
      self.ReLU2Map12.Height := 14;
      self.ReLU2Map12.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map12.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map12);
      //-> Map13
      self.ReLU2Map13 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map13.Top := 323;
      self.ReLU2Map13.Left := 17;
      self.ReLU2Map13.Width := 14;
      self.ReLU2Map13.Height := 14;
      self.ReLU2Map13.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map13.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map13);
      //-> Map14
      self.ReLU2Map14 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map14.Top := 347;
      self.ReLU2Map14.Left := 17;
      self.ReLU2Map14.Width := 14;
      self.ReLU2Map14.Height := 14;
      self.ReLU2Map14.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map14.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map14);
      //-> Map15
      self.ReLU2Map15 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map15.Top := 371;
      self.ReLU2Map15.Left := 17;
      self.ReLU2Map15.Width := 14;
      self.ReLU2Map15.Height := 14;
      self.ReLU2Map15.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map15.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map15);
      //-> Map16
      self.ReLU2Map16 := new System.Windows.Forms.PictureBox();
      self.ReLU2Map16.Top := 395;
      self.ReLU2Map16.Left := 17;
      self.ReLU2Map16.Width := 14;
      self.ReLU2Map16.Height := 14;
      self.ReLU2Map16.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.ReLU2Map16.BackColor := System.Drawing.Color.Gray;
      self.ReLU2Panel.Controls.Add(self.ReLU2Map16);
      self.Controls.Add(self.ReLU2Panel);
      //-> Pool2Label
      self.Pool2Label := new System.Windows.Forms.Label();
      self.Pool2Label.Text := 'Pool2';
      self.Pool2Label.Left := 576;
      self.Pool2Label.Width := 48;
      self.Pool2Label.Height := 25;
      self.Pool2Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.Pool2Label);
      //-> Pool2Panel
      self.Pool2Panel := new System.Windows.Forms.Panel();
      self.Pool2Panel.Top := 25;
      self.Pool2Panel.Left := 576;
      self.Pool2Panel.Width := 48;
      self.Pool2Panel.Height := 445;
      self.Pool2Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.Pool2Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.Pool2Map1 := new System.Windows.Forms.PictureBox();
      self.Pool2Map1.Top := 91;
      self.Pool2Map1.Left := 20;
      self.Pool2Map1.Width := 7;
      self.Pool2Map1.Height := 7;
      self.Pool2Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map1.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map1);
      //-> Map2
      self.Pool2Map2 := new System.Windows.Forms.PictureBox();
      self.Pool2Map2.Top := 108;
      self.Pool2Map2.Left := 20;
      self.Pool2Map2.Width := 7;
      self.Pool2Map2.Height := 7;
      self.Pool2Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map2.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map2);
      //-> Map3
      self.Pool2Map3 := new System.Windows.Forms.PictureBox();
      self.Pool2Map3.Top := 125;
      self.Pool2Map3.Left := 20;
      self.Pool2Map3.Width := 7;
      self.Pool2Map3.Height := 7;
      self.Pool2Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map3.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map3);
      //-> Map4
      self.Pool2Map4 := new System.Windows.Forms.PictureBox();
      self.Pool2Map4.Top := 142;
      self.Pool2Map4.Left := 20;
      self.Pool2Map4.Width := 7;
      self.Pool2Map4.Height := 7;
      self.Pool2Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map4.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map4);
      //-> Map5
      self.Pool2Map5 := new System.Windows.Forms.PictureBox();
      self.Pool2Map5.Top := 159;
      self.Pool2Map5.Left := 20;
      self.Pool2Map5.Width := 7;
      self.Pool2Map5.Height := 7;
      self.Pool2Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map5.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map5);
      //-> Map6
      self.Pool2Map6 := new System.Windows.Forms.PictureBox();
      self.Pool2Map6.Top := 176;
      self.Pool2Map6.Left := 20;
      self.Pool2Map6.Width := 7;
      self.Pool2Map6.Height := 7;
      self.Pool2Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map6.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map6);
      //-> Map7
      self.Pool2Map7 := new System.Windows.Forms.PictureBox();
      self.Pool2Map7.Top := 193;
      self.Pool2Map7.Left := 20;
      self.Pool2Map7.Width := 7;
      self.Pool2Map7.Height := 7;
      self.Pool2Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map7.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map7);
      //-> Map8
      self.Pool2Map8 := new System.Windows.Forms.PictureBox();
      self.Pool2Map8.Top := 210;
      self.Pool2Map8.Left := 20;
      self.Pool2Map8.Width := 7;
      self.Pool2Map8.Height := 7;
      self.Pool2Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map8.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map8);
      //-> Map9
      self.Pool2Map9 := new System.Windows.Forms.PictureBox();
      self.Pool2Map9.Top := 227;
      self.Pool2Map9.Left := 20;
      self.Pool2Map9.Width := 7;
      self.Pool2Map9.Height := 7;
      self.Pool2Map9.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map9.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map9);
      //-> Map10
      self.Pool2Map10 := new System.Windows.Forms.PictureBox();
      self.Pool2Map10.Top := 244;
      self.Pool2Map10.Left := 20;
      self.Pool2Map10.Width := 7;
      self.Pool2Map10.Height := 7;
      self.Pool2Map10.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map10.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map10);
      //-> Map11
      self.Pool2Map11 := new System.Windows.Forms.PictureBox();
      self.Pool2Map11.Top := 261;
      self.Pool2Map11.Left := 20;
      self.Pool2Map11.Width := 7;
      self.Pool2Map11.Height := 7;
      self.Pool2Map11.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map11.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map11);
      //-> Map12
      self.Pool2Map12 := new System.Windows.Forms.PictureBox();
      self.Pool2Map12.Top := 278;
      self.Pool2Map12.Left := 20;
      self.Pool2Map12.Width := 7;
      self.Pool2Map12.Height := 7;
      self.Pool2Map12.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map12.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map12);
      //-> Map13
      self.Pool2Map13 := new System.Windows.Forms.PictureBox();
      self.Pool2Map13.Top := 295;
      self.Pool2Map13.Left := 20;
      self.Pool2Map13.Width := 7;
      self.Pool2Map13.Height := 7;
      self.Pool2Map13.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map13.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map13);
      //-> Map14
      self.Pool2Map14 := new System.Windows.Forms.PictureBox();
      self.Pool2Map14.Top := 312;
      self.Pool2Map14.Left := 20;
      self.Pool2Map14.Width := 7;
      self.Pool2Map14.Height := 7;
      self.Pool2Map14.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map14.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map14);
      //-> Map15
      self.Pool2Map15 := new System.Windows.Forms.PictureBox();
      self.Pool2Map15.Top := 329;
      self.Pool2Map15.Left := 20;
      self.Pool2Map15.Width := 7;
      self.Pool2Map15.Height := 7;
      self.Pool2Map15.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map15.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map15);
      //-> Map16
      self.Pool2Map16 := new System.Windows.Forms.PictureBox();
      self.Pool2Map16.Top := 346;
      self.Pool2Map16.Left := 20;
      self.Pool2Map16.Width := 7;
      self.Pool2Map16.Height := 7;
      self.Pool2Map16.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.Pool2Map16.BackColor := System.Drawing.Color.Gray;
      self.Pool2Panel.Controls.Add(self.Pool2Map16);
      self.Controls.Add(self.Pool2Panel);
      //-> FC1Label
      self.FC1Label := new System.Windows.Forms.Label();
      self.FC1Label.Text := 'FC1';
      self.FC1Label.Left := 634;
      self.FC1Label.Width := 48;
      self.FC1Label.Height := 25;
      self.FC1Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.FC1Label);
      //-> FC1Panel
      self.FC1Panel := new System.Windows.Forms.Panel();
      self.FC1Panel.Top := 25;
      self.FC1Panel.Left := 634;
      self.FC1Panel.Width := 48;
      self.FC1Panel.Height := 445;
      self.FC1Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.FC1Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.FC1Map1 := new System.Windows.Forms.PictureBox();
      self.FC1Map1.Top := 142;
      self.FC1Map1.Left := 20;
      self.FC1Map1.Width := 7;
      self.FC1Map1.Height := 7;
      self.FC1Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map1.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map1);
      //-> Map2
      self.FC1Map2 := new System.Windows.Forms.PictureBox();
      self.FC1Map2.Top := 159;
      self.FC1Map2.Left := 20;
      self.FC1Map2.Width := 7;
      self.FC1Map2.Height := 7;
      self.FC1Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map2.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map2);
      //-> Map3
      self.FC1Map3 := new System.Windows.Forms.PictureBox();
      self.FC1Map3.Top := 176;
      self.FC1Map3.Left := 20;
      self.FC1Map3.Width := 7;
      self.FC1Map3.Height := 7;
      self.FC1Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map3.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map3);
      //-> Map4
      self.FC1Map4 := new System.Windows.Forms.PictureBox();
      self.FC1Map4.Top := 193;
      self.FC1Map4.Left := 20;
      self.FC1Map4.Width := 7;
      self.FC1Map4.Height := 7;
      self.FC1Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map4.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map4);
      //-> Map5
      self.FC1Map5 := new System.Windows.Forms.PictureBox();
      self.FC1Map5.Top := 210;
      self.FC1Map5.Left := 20;
      self.FC1Map5.Width := 7;
      self.FC1Map5.Height := 7;
      self.FC1Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map5.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map5);
      //-> Map6
      self.FC1Map6 := new System.Windows.Forms.PictureBox();
      self.FC1Map6.Top := 227;
      self.FC1Map6.Left := 20;
      self.FC1Map6.Width := 7;
      self.FC1Map6.Height := 7;
      self.FC1Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map6.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map6);
      //-> Map7
      self.FC1Map7 := new System.Windows.Forms.PictureBox();
      self.FC1Map7.Top := 244;
      self.FC1Map7.Left := 20;
      self.FC1Map7.Width := 7;
      self.FC1Map7.Height := 7;
      self.FC1Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map7.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map7);
      //-> Map8
      self.FC1Map8 := new System.Windows.Forms.PictureBox();
      self.FC1Map8.Top := 261;
      self.FC1Map8.Left := 20;
      self.FC1Map8.Width := 7;
      self.FC1Map8.Height := 7;
      self.FC1Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map8.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map8);
      //-> Map9
      self.FC1Map9 := new System.Windows.Forms.PictureBox();
      self.FC1Map9.Top := 278;
      self.FC1Map9.Left := 20;
      self.FC1Map9.Width := 7;
      self.FC1Map9.Height := 7;
      self.FC1Map9.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map9.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map9);
      //-> Map10
      self.FC1Map10 := new System.Windows.Forms.PictureBox();
      self.FC1Map10.Top := 295;
      self.FC1Map10.Left := 20;
      self.FC1Map10.Width := 7;
      self.FC1Map10.Height := 7;
      self.FC1Map10.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.FC1Map10.BackColor := System.Drawing.Color.Gray;
      self.FC1Panel.Controls.Add(self.FC1Map10);
      self.Controls.Add(self.FC1Panel);
      //-> SM1Label
      self.SM1Label := new System.Windows.Forms.Label();
      self.SM1Label.Text := 'SM1';
      self.SM1Label.Left := 692;
      self.SM1Label.Width := 48;
      self.SM1Label.Height := 25;
      self.SM1Label.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.SM1Label);
      //-> SM1Panel
      self.SM1Panel := new System.Windows.Forms.Panel();
      self.SM1Panel.Top := 25;
      self.SM1Panel.Left := 692;
      self.SM1Panel.Width := 48;
      self.SM1Panel.Height := 445;
      self.SM1Panel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.SM1Panel.BackColor := System.Drawing.Color.White;
      //-> Map1
      self.SM1Map1 := new System.Windows.Forms.PictureBox();
      self.SM1Map1.Top := 142;
      self.SM1Map1.Left := 20;
      self.SM1Map1.Width := 7;
      self.SM1Map1.Height := 7;
      self.SM1Map1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map1.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map1);
      //-> Map2
      self.SM1Map2 := new System.Windows.Forms.PictureBox();
      self.SM1Map2.Top := 159;
      self.SM1Map2.Left := 20;
      self.SM1Map2.Width := 7;
      self.SM1Map2.Height := 7;
      self.SM1Map2.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map2.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map2);
      //-> Map3
      self.SM1Map3 := new System.Windows.Forms.PictureBox();
      self.SM1Map3.Top := 176;
      self.SM1Map3.Left := 20;
      self.SM1Map3.Width := 7;
      self.SM1Map3.Height := 7;
      self.SM1Map3.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map3.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map3);
      //-> Map4
      self.SM1Map4 := new System.Windows.Forms.PictureBox();
      self.SM1Map4.Top := 193;
      self.SM1Map4.Left := 20;
      self.SM1Map4.Width := 7;
      self.SM1Map4.Height := 7;
      self.SM1Map4.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map4.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map4);
      //-> Map5
      self.SM1Map5 := new System.Windows.Forms.PictureBox();
      self.SM1Map5.Top := 210;
      self.SM1Map5.Left := 20;
      self.SM1Map5.Width := 7;
      self.SM1Map5.Height := 7;
      self.SM1Map5.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map5.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map5);
      //-> Map6
      self.SM1Map6 := new System.Windows.Forms.PictureBox();
      self.SM1Map6.Top := 227;
      self.SM1Map6.Left := 20;
      self.SM1Map6.Width := 7;
      self.SM1Map6.Height := 7;
      self.SM1Map6.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map6.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map6);
      //-> Map7
      self.SM1Map7 := new System.Windows.Forms.PictureBox();
      self.SM1Map7.Top := 244;
      self.SM1Map7.Left := 20;
      self.SM1Map7.Width := 7;
      self.SM1Map7.Height := 7;
      self.SM1Map7.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map7.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map7);
      //-> Map8
      self.SM1Map8 := new System.Windows.Forms.PictureBox();
      self.SM1Map8.Top := 261;
      self.SM1Map8.Left := 20;
      self.SM1Map8.Width := 7;
      self.SM1Map8.Height := 7;
      self.SM1Map8.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map8.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map8);
      //-> Map9
      self.SM1Map9 := new System.Windows.Forms.PictureBox();
      self.SM1Map9.Top := 278;
      self.SM1Map9.Left := 20;
      self.SM1Map9.Width := 7;
      self.SM1Map9.Height := 7;
      self.SM1Map9.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map9.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map9);
      //-> Map10
      self.SM1Map10 := new System.Windows.Forms.PictureBox();
      self.SM1Map10.Top := 295;
      self.SM1Map10.Left := 20;
      self.SM1Map10.Width := 7;
      self.SM1Map10.Height := 7;
      self.SM1Map10.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.SM1Map10.BackColor := System.Drawing.Color.Gray;
      self.SM1Panel.Controls.Add(self.SM1Map10);
      self.Controls.Add(self.SM1Panel);
      //-> PredictionLabel
      self.PredictionLabel := new System.Windows.Forms.Label();
      self.PredictionLabel.Left := 750;
      self.PredictionLabel.Width := 96;
      self.PredictionLabel.Height := 25;
      self.PredictionLabel.Top := 179;
      self.PredictionLabel.Text := 'Prediction';
      self.PredictionLabel.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.Controls.Add(self.PredictionLabel);
      //-> PredictionPanel
      self.PredictionPanel := new System.Windows.Forms.Panel();
      self.PredictionPanel.Top := 204;
      self.PredictionPanel.Left := 750;
      self.PredictionPanel.Width := 96;
      self.PredictionPanel.Height := 96;
      self.PredictionPanel.BackColor := System.Drawing.Color.White;
      self.PredictionPanel.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
      self.PredictionResult := new System.Windows.Forms.Label;
      self.PredictionResult.Font := new System.Drawing.Font('Segoe Script', 50);
      self.PredictionResult.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
      self.PredictionResult.Top := 10;
      self.PredictionResult.Left := 10;
      self.PredictionResult.Width := 76;
      self.PredictionResult.Height := 76;
      self.PredictionResult.BackColor := System.Drawing.Color.Gray;
      self.PredictionResult.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
      self.PredictionPanel.Controls.Add(self.PredictionResult);
      self.Controls.Add(self.PredictionPanel);
      System.GC.Collect();
    end;
    
    private procedure SetConv1Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.Conv1Map1.Image := maps[0];
      self.Conv1Map2.Image := maps[1];
      self.Conv1Map3.Image := maps[2];
      self.Conv1Map4.Image := maps[3];
      self.Conv1Map5.Image := maps[4];
      self.Conv1Map6.Image := maps[5];
      self.Conv1Map7.Image := maps[6];
      self.Conv1Map8.Image := maps[7];
      self.Conv1Map1.Invalidate();
      self.Conv1Map2.Invalidate();
      self.Conv1Map3.Invalidate();
      self.Conv1Map4.Invalidate();
      self.Conv1Map5.Invalidate();
      self.Conv1Map6.Invalidate();
      self.Conv1Map7.Invalidate();
      self.Conv1Map8.Invalidate();
    end;
    
    private procedure SetReLU1Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.ReLU1Map1.Image := maps[0];
      self.ReLU1Map2.Image := maps[1];
      self.ReLU1Map3.Image := maps[2];
      self.ReLU1Map4.Image := maps[3];
      self.ReLU1Map5.Image := maps[4];
      self.ReLU1Map6.Image := maps[5];
      self.ReLU1Map7.Image := maps[6];
      self.ReLU1Map8.Image := maps[7];
      self.ReLU1Map1.Invalidate();
      self.ReLU1Map2.Invalidate();
      self.ReLU1Map3.Invalidate();
      self.ReLU1Map4.Invalidate();
      self.ReLU1Map5.Invalidate();
      self.ReLU1Map6.Invalidate();
      self.ReLU1Map7.Invalidate();
      self.ReLU1Map8.Invalidate();
    end;
    
    private procedure SetPool1Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.Pool1Map1.Image := maps[0];
      self.Pool1Map2.Image := maps[1];
      self.Pool1Map3.Image := maps[2];
      self.Pool1Map4.Image := maps[3];
      self.Pool1Map5.Image := maps[4];
      self.Pool1Map6.Image := maps[5];
      self.Pool1Map7.Image := maps[6];
      self.Pool1Map8.Image := maps[7];
      self.Pool1Map1.Invalidate();
      self.Pool1Map2.Invalidate();
      self.Pool1Map3.Invalidate();
      self.Pool1Map4.Invalidate();
      self.Pool1Map5.Invalidate();
      self.Pool1Map6.Invalidate();
      self.Pool1Map7.Invalidate();
      self.Pool1Map8.Invalidate();
    end;
    
    private procedure SetConv2Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.Conv2Map1.Image := maps[0];
      self.Conv2Map2.Image := maps[1];
      self.Conv2Map3.Image := maps[2];
      self.Conv2Map4.Image := maps[3];
      self.Conv2Map5.Image := maps[4];
      self.Conv2Map6.Image := maps[5];
      self.Conv2Map7.Image := maps[6];
      self.Conv2Map8.Image := maps[7];
      self.Conv2Map9.Image := maps[8];
      self.Conv2Map10.Image := maps[9];
      self.Conv2Map11.Image := maps[10];
      self.Conv2Map12.Image := maps[11];
      self.Conv2Map13.Image := maps[12];
      self.Conv2Map14.Image := maps[13];
      self.Conv2Map15.Image := maps[14];
      self.Conv2Map16.Image := maps[15];
      self.Conv2Map1.Invalidate();
      self.Conv2Map2.Invalidate();
      self.Conv2Map3.Invalidate();
      self.Conv2Map4.Invalidate();
      self.Conv2Map5.Invalidate();
      self.Conv2Map6.Invalidate();
      self.Conv2Map7.Invalidate();
      self.Conv2Map8.Invalidate();
      self.Conv2Map9.Invalidate();
      self.Conv2Map10.Invalidate();
      self.Conv2Map11.Invalidate();
      self.Conv2Map12.Invalidate();
      self.Conv2Map13.Invalidate();
      self.Conv2Map14.Invalidate();
      self.Conv2Map15.Invalidate();
      self.Conv2Map16.Invalidate();
    end;
    
    private procedure SetReLU2Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.ReLU2Map1.Image := maps[0];
      self.ReLU2Map2.Image := maps[1];
      self.ReLU2Map3.Image := maps[2];
      self.ReLU2Map4.Image := maps[3];
      self.ReLU2Map5.Image := maps[4];
      self.ReLU2Map6.Image := maps[5];
      self.ReLU2Map7.Image := maps[6];
      self.ReLU2Map8.Image := maps[7];
      self.ReLU2Map9.Image := maps[8];
      self.ReLU2Map10.Image := maps[9];
      self.ReLU2Map11.Image := maps[10];
      self.ReLU2Map12.Image := maps[11];
      self.ReLU2Map13.Image := maps[12];
      self.ReLU2Map14.Image := maps[13];
      self.ReLU2Map15.Image := maps[14];
      self.ReLU2Map16.Image := maps[15];
      self.ReLU2Map1.Invalidate();
      self.ReLU2Map2.Invalidate();
      self.ReLU2Map3.Invalidate();
      self.ReLU2Map4.Invalidate();
      self.ReLU2Map5.Invalidate();
      self.ReLU2Map6.Invalidate();
      self.ReLU2Map7.Invalidate();
      self.ReLU2Map8.Invalidate();
      self.ReLU2Map9.Invalidate();
      self.ReLU2Map10.Invalidate();
      self.ReLU2Map11.Invalidate();
      self.ReLU2Map12.Invalidate();
      self.ReLU2Map13.Invalidate();
      self.ReLU2Map14.Invalidate();
      self.ReLU2Map15.Invalidate();
      self.ReLU2Map16.Invalidate();
    end;
    
    private procedure SetPool2Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.Pool2Map1.Image := maps[0];
      self.Pool2Map2.Image := maps[1];
      self.Pool2Map3.Image := maps[2];
      self.Pool2Map4.Image := maps[3];
      self.Pool2Map5.Image := maps[4];
      self.Pool2Map6.Image := maps[5];
      self.Pool2Map7.Image := maps[6];
      self.Pool2Map8.Image := maps[7];
      self.Pool2Map9.Image := maps[8];
      self.Pool2Map10.Image := maps[9];
      self.Pool2Map11.Image := maps[10];
      self.Pool2Map12.Image := maps[11];
      self.Pool2Map13.Image := maps[12];
      self.Pool2Map14.Image := maps[13];
      self.Pool2Map15.Image := maps[14];
      self.Pool2Map16.Image := maps[15];
      self.Pool2Map1.Invalidate();
      self.Pool2Map2.Invalidate();
      self.Pool2Map3.Invalidate();
      self.Pool2Map4.Invalidate();
      self.Pool2Map5.Invalidate();
      self.Pool2Map6.Invalidate();
      self.Pool2Map7.Invalidate();
      self.Pool2Map8.Invalidate();
      self.Pool2Map9.Invalidate();
      self.Pool2Map10.Invalidate();
      self.Pool2Map11.Invalidate();
      self.Pool2Map12.Invalidate();
      self.Pool2Map13.Invalidate();
      self.Pool2Map14.Invalidate();
      self.Pool2Map15.Invalidate();
      self.Pool2Map16.Invalidate();
    end;
    
    private procedure SetFC1Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.FC1Map1.Image := maps[0];
      self.FC1Map2.Image := maps[1];
      self.FC1Map3.Image := maps[2];
      self.FC1Map4.Image := maps[3];
      self.FC1Map5.Image := maps[4];
      self.FC1Map6.Image := maps[5];
      self.FC1Map7.Image := maps[6];
      self.FC1Map8.Image := maps[7];
      self.FC1Map9.Image := maps[8];
      self.FC1Map10.Image := maps[9];
      self.FC1Map1.Invalidate();
      self.FC1Map2.Invalidate();
      self.FC1Map3.Invalidate();
      self.FC1Map4.Invalidate();
      self.FC1Map5.Invalidate();
      self.FC1Map6.Invalidate();
      self.FC1Map7.Invalidate();
      self.FC1Map8.Invalidate();
      self.FC1Map9.Invalidate();
      self.FC1Map10.Invalidate();
    end;
    
    private procedure SetSM1Maps(params maps: array of System.Drawing.Bitmap);
    begin
      self.SM1Map1.Image := maps[0];
      self.SM1Map2.Image := maps[1];
      self.SM1Map3.Image := maps[2];
      self.SM1Map4.Image := maps[3];
      self.SM1Map5.Image := maps[4];
      self.SM1Map6.Image := maps[5];
      self.SM1Map7.Image := maps[6];
      self.SM1Map8.Image := maps[7];
      self.SM1Map9.Image := maps[8];
      self.SM1Map10.Image := maps[9];
      self.SM1Map1.Invalidate();
      self.SM1Map2.Invalidate();
      self.SM1Map3.Invalidate();
      self.SM1Map4.Invalidate();
      self.SM1Map5.Invalidate();
      self.SM1Map6.Invalidate();
      self.SM1Map7.Invalidate();
      self.SM1Map8.Invalidate();
      self.SM1Map9.Invalidate();
      self.SM1Map10.Invalidate();
    end;
    
    private procedure Recognize(sender: System.object; E: System.EventArgs);
    begin
      var Temp := new System.Drawing.Bitmap(self.MainDrawingBox.BMP, 28, 28);
      var Input := Tensor.FromGrayScaleBMP(Temp);
      var Conv1 := Layers.Conv(Input, self.Conv1Biases, self.Conv1Filters, 2, 1, 5, 5);
      self.SetConv1Maps(Conv1.ToBitmaps());
      var ReLU1 := Layers.ReLU(Conv1);
      self.SetReLU1Maps(ReLU1.ToBitmaps());
      var Pool1 := Layers.Pool(ReLU1, 2, 2, 2, 0);
      self.SetPool1Maps(Pool1.ToBitmaps());
      var Conv2 := Layers.Conv(Pool1, self.Conv2Biases, self.Conv2Filters, 2, 1, 5, 5);
      self.SetConv2Maps(Conv2.ToBitmaps());
      var ReLU2 := Layers.ReLU(Conv2);
      self.SetReLU2Maps(ReLU2.ToBitmaps());
      var Pool2 := Layers.Pool(ReLU2, 2, 2, 2, 0);
      self.SetPool2Maps(Pool2.ToBitmaps());
      var FC1 := Layers.FullyConn(Pool2, self.FC1Biases, self.FC1Filters);
      self.SetFC1Maps(self.ResizeImages(7, 7, FC1.ToBitmaps()));
      var SM1 := Layers.SoftMax(FC1);
      self.SetSM1Maps(self.ResizeImages(7, 7, SM1.ToBitmaps()));
      self.PredictionResult.Text := self.GetPrediction(SM1).ToString();
      Temp := nil;
      Input := nil;
      Conv1 := nil;
      ReLU1 := nil;
      Pool1 := nil;
      Conv2 := nil;
      ReLU2 := nil;
      Pool2 := nil;
      FC1 := nil;
      SM1 := nil;
      System.GC.Collect();
    end;
    
    private procedure ClearInput(sender: System.object; E: System.EventArgs);
    begin
      //-> MainDrawingBox
      self.MainDrawingBox.Clear();
      //-> Conv1Maps
      self.Conv1Map1.Image := nil;
      self.Conv1Map1.Invalidate();
      self.Conv1Map2.Image := nil;
      self.Conv1Map2.Invalidate();
      self.Conv1Map3.Image := nil;
      self.Conv1Map3.Invalidate();
      self.Conv1Map4.Image := nil;
      self.Conv1Map4.Invalidate();
      self.Conv1Map5.Image := nil;
      self.Conv1Map5.Invalidate();
      self.Conv1Map6.Image := nil;
      self.Conv1Map6.Invalidate();
      self.Conv1Map7.Image := nil;
      self.Conv1Map7.Invalidate();
      self.Conv1Map8.Image := nil;
      self.Conv1Map8.Invalidate();
      //-> ReLU1Maps
      self.ReLU1Map1.Image := nil;
      self.ReLU1Map1.Invalidate();
      self.ReLU1Map2.Image := nil;
      self.ReLU1Map2.Invalidate();
      self.ReLU1Map3.Image := nil;
      self.ReLU1Map3.Invalidate();
      self.ReLU1Map4.Image := nil;
      self.ReLU1Map4.Invalidate();
      self.ReLU1Map5.Image := nil;
      self.ReLU1Map5.Invalidate();
      self.ReLU1Map6.Image := nil;
      self.ReLU1Map6.Invalidate();
      self.ReLU1Map7.Image := nil;
      self.ReLU1Map7.Invalidate();
      self.ReLU1Map8.Image := nil;
      self.ReLU1Map8.Invalidate();
      //-> Pool1Maps
      self.Pool1Map1.Image := nil;
      self.Pool1Map1.Invalidate();
      self.Pool1Map2.Image := nil;
      self.Pool1Map2.Invalidate();
      self.Pool1Map3.Image := nil;
      self.Pool1Map3.Invalidate();
      self.Pool1Map4.Image := nil;
      self.Pool1Map4.Invalidate();
      self.Pool1Map5.Image := nil;
      self.Pool1Map5.Invalidate();
      self.Pool1Map6.Image := nil;
      self.Pool1Map6.Invalidate();
      self.Pool1Map7.Image := nil;
      self.Pool1Map7.Invalidate();
      self.Pool1Map8.Image := nil;
      self.Pool1Map8.Invalidate();
      //-> Conv2Maps
      self.Conv2Map1.Image := nil;
      self.Conv2Map1.Invalidate();
      self.Conv2Map2.Image := nil;
      self.Conv2Map2.Invalidate();
      self.Conv2Map3.Image := nil;
      self.Conv2Map3.Invalidate();
      self.Conv2Map4.Image := nil;
      self.Conv2Map4.Invalidate();
      self.Conv2Map5.Image := nil;
      self.Conv2Map5.Invalidate();
      self.Conv2Map6.Image := nil;
      self.Conv2Map6.Invalidate();
      self.Conv2Map7.Image := nil;
      self.Conv2Map7.Invalidate();
      self.Conv2Map8.Image := nil;
      self.Conv2Map8.Invalidate();
      self.Conv2Map9.Image := nil;
      self.Conv2Map9.Invalidate();
      self.Conv2Map10.Image := nil;
      self.Conv2Map10.Invalidate();
      self.Conv2Map11.Image := nil;
      self.Conv2Map11.Invalidate();
      self.Conv2Map12.Image := nil;
      self.Conv2Map12.Invalidate();
      self.Conv2Map13.Image := nil;
      self.Conv2Map13.Invalidate();
      self.Conv2Map14.Image := nil;
      self.Conv2Map14.Invalidate();
      self.Conv2Map15.Image := nil;
      self.Conv2Map15.Invalidate();
      self.Conv2Map16.Image := nil;
      self.Conv2Map16.Invalidate();
      //-> ReLU2Maps
      self.ReLU2Map1.Image := nil;
      self.ReLU2Map1.Invalidate();
      self.ReLU2Map2.Image := nil;
      self.ReLU2Map2.Invalidate();
      self.ReLU2Map3.Image := nil;
      self.ReLU2Map3.Invalidate();
      self.ReLU2Map4.Image := nil;
      self.ReLU2Map4.Invalidate();
      self.ReLU2Map5.Image := nil;
      self.ReLU2Map5.Invalidate();
      self.ReLU2Map6.Image := nil;
      self.ReLU2Map6.Invalidate();
      self.ReLU2Map7.Image := nil;
      self.ReLU2Map7.Invalidate();
      self.ReLU2Map8.Image := nil;
      self.ReLU2Map8.Invalidate();
      self.ReLU2Map9.Image := nil;
      self.ReLU2Map9.Invalidate();
      self.ReLU2Map10.Image := nil;
      self.ReLU2Map10.Invalidate();
      self.ReLU2Map11.Image := nil;
      self.ReLU2Map11.Invalidate();
      self.ReLU2Map12.Image := nil;
      self.ReLU2Map12.Invalidate();
      self.ReLU2Map13.Image := nil;
      self.ReLU2Map13.Invalidate();
      self.ReLU2Map14.Image := nil;
      self.ReLU2Map14.Invalidate();
      self.ReLU2Map15.Image := nil;
      self.ReLU2Map15.Invalidate();
      self.ReLU2Map16.Image := nil;
      self.ReLU2Map16.Invalidate();
      //-> Pool2Maps
      self.Pool2Map1.Image := nil;
      self.Pool2Map1.Invalidate();
      self.Pool2Map2.Image := nil;
      self.Pool2Map2.Invalidate();
      self.Pool2Map3.Image := nil;
      self.Pool2Map3.Invalidate();
      self.Pool2Map4.Image := nil;
      self.Pool2Map4.Invalidate();
      self.Pool2Map5.Image := nil;
      self.Pool2Map5.Invalidate();
      self.Pool2Map6.Image := nil;
      self.Pool2Map6.Invalidate();
      self.Pool2Map7.Image := nil;
      self.Pool2Map7.Invalidate();
      self.Pool2Map8.Image := nil;
      self.Pool2Map8.Invalidate();
      self.Pool2Map9.Image := nil;
      self.Pool2Map9.Invalidate();
      self.Pool2Map10.Image := nil;
      self.Pool2Map10.Invalidate();
      self.Pool2Map11.Image := nil;
      self.Pool2Map11.Invalidate();
      self.Pool2Map12.Image := nil;
      self.Pool2Map12.Invalidate();
      self.Pool2Map13.Image := nil;
      self.Pool2Map13.Invalidate();
      self.Pool2Map14.Image := nil;
      self.Pool2Map14.Invalidate();
      self.Pool2Map15.Image := nil;
      self.Pool2Map15.Invalidate();
      self.Pool2Map16.Image := nil;
      self.Pool2Map16.Invalidate();
      //-> FC1Maps
      self.FC1Map1.Image := nil;
      self.FC1Map1.Invalidate();
      self.FC1Map2.Image := nil;
      self.FC1Map2.Invalidate();
      self.FC1Map3.Image := nil;
      self.FC1Map3.Invalidate();
      self.FC1Map4.Image := nil;
      self.FC1Map4.Invalidate();
      self.FC1Map5.Image := nil;
      self.FC1Map5.Invalidate();
      self.FC1Map6.Image := nil;
      self.FC1Map6.Invalidate();
      self.FC1Map7.Image := nil;
      self.FC1Map7.Invalidate();
      self.FC1Map8.Image := nil;
      self.FC1Map8.Invalidate();
      self.FC1Map9.Image := nil;
      self.FC1Map9.Invalidate();
      self.FC1Map10.Image := nil;
      self.FC1Map10.Invalidate();
      //-> SM1Maps
      self.SM1Map1.Image := nil;
      self.SM1Map1.Invalidate();
      self.SM1Map2.Image := nil;
      self.SM1Map2.Invalidate();
      self.SM1Map3.Image := nil;
      self.SM1Map3.Invalidate();
      self.SM1Map4.Image := nil;
      self.SM1Map4.Invalidate();
      self.SM1Map5.Image := nil;
      self.SM1Map5.Invalidate();
      self.SM1Map6.Image := nil;
      self.SM1Map6.Invalidate();
      self.SM1Map7.Image := nil;
      self.SM1Map7.Invalidate();
      self.SM1Map8.Image := nil;
      self.SM1Map8.Invalidate();
      self.SM1Map9.Image := nil;
      self.SM1Map9.Invalidate();
      self.SM1Map10.Image := nil;
      self.SM1Map10.Invalidate();
      self.PredictionResult.Text := nil;
      self.PredictionResult.Invalidate();
      System.GC.Collect();
    end;
  End;

begin
  //-> Create and run application
  System.Windows.Forms.Application.Run(new MainForm());
end.